# coding: utf-8
"""
    NewsCatcher-V3 Production API

    <img src='https://uploads-ssl.webflow.com/6429857b17973b636c2195c5/646c6f1eb774ff2f2997bec5_newscatcher_.svg' width='286' height='35' /> <br>  <br>Visit our website  <a href='https://newscatcherapi.com'>https://newscatcherapi.com</a>

    The version of the OpenAPI document: Beta-3.0.0
    Contact: maksym@newscatcherapi.com
    Generated by: https://konfigthis.com
"""

import typing
import inspect
from datetime import date, datetime
from newscatcherapi_client.client_custom import ClientCustom
from newscatcherapi_client.configuration import Configuration
from newscatcherapi_client.api_client import ApiClient
from newscatcherapi_client.type_util import copy_signature
from newscatcherapi_client.apis.tags.authors_api import AuthorsApi
from newscatcherapi_client.apis.tags.latest_headlines_api import LatestHeadlinesApi
from newscatcherapi_client.apis.tags.search_api import SearchApi
from newscatcherapi_client.apis.tags.search_similar_api import SearchSimilarApi
from newscatcherapi_client.apis.tags.sources_api import SourcesApi
from newscatcherapi_client.apis.tags.subscription_api import SubscriptionApi



class Newscatcher(ClientCustom):

    def __init__(self, configuration: typing.Union[Configuration, None] = None, **kwargs):
        super().__init__(configuration, **kwargs)
        if (len(kwargs) > 0):
            configuration = Configuration(**kwargs)
        if (configuration is None):
            raise Exception("configuration is required")
        api_client = ApiClient(configuration)
        self.authors: AuthorsApi = AuthorsApi(api_client)
        self.latest_headlines: LatestHeadlinesApi = LatestHeadlinesApi(api_client)
        self.search: SearchApi = SearchApi(api_client)
        self.search_similar: SearchSimilarApi = SearchSimilarApi(api_client)
        self.sources: SourcesApi = SourcesApi(api_client)
        self.subscription: SubscriptionApi = SubscriptionApi(api_client)
